######################################################################
###                     Functions library                          ###
######################################################################

Wait4rc () {
  echo "          Wait a few sec to be sure rc.local is not starting too fast "
  echo
  sleep $1
}

Main_Banner () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **      Building MoOde Audio Procedure (Image Prep)            **"
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
} 

Main_Banner_PI_3 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                   First Boot - Step 3                       **"
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_4 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Second Boot - Step 4                       **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_5 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Third Boot - Step 5                        **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_6 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Fourth Boot - Step 6                       **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_8 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Fifth Boot - Step 8                       **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_10 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Sixth Boot - Step 10                       **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10
}

Main_Banner_PI_12 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Seventh Boot - Step 12                     **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10 
}

Main_Banner_PI_13 () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  Eighth Boot - Step 13                      **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  Wait4rc 10 
}

Load_Properties () {
  local PROPERTIES_FILE=./install_moOde.properties
  
  if [ -z "$1" ] ; then 
    if [ -f $PROPERTIES_FILE ] ; then
      . $PROPERTIES_FILE
      echo "          Loading environment parameters : OK"
    else
      echo "          ==> ERROR : Unable to find parameters file : PROPERTIES_FILE !"  
      exit 1
    fi
  else
    PROPERTIES_FILE=$1
    if [ -f $PROPERTIES_FILE ] ; then
      . $PROPERTIES_FILE
      echo "          Loading environment parameters : OK"
    else
      echo "          ==> ERROR : Unable to find parameters file : PROPERTIES_FILE !"  
      exit 1
    fi   
  fi	
  echo
}

Identify_nb_core () {
  echo
  echo "          How many cores are available for best compile time ? "
  echo 
  PARALLEL=`lscpu |grep CPU | head -1 |awk -F" " '{ print $NF}'`
  echo
  echo "          It looks like we can submit $PARALLEL jobs to gcc "
  echo
}

Download_OS_Image () {
  local FILE_RASPBIAN=`echo $RASPIAN_OS | awk -F"/" '{ print $NF }'`
 
  echo " ***** STEP 1 : Preparing Raspian Image ... *****"
  echo
  echo "          Downloading Rasbian Image $FILE_RASPBIAN"  
  if [ -f $FILE_RASPBIAN ] ; then 
    echo "          ==> WARNING : $FILE_RASPBIAN already exists ... downloading a new one !"
	echo
    rm -f $FILE_RASPBIAN
  fi
  echo
  wget $RASPIAN_OS
  echo
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to download Raspbian Image at : $RASPIAN_OS"
	exit 1 
  else 
    echo "          Raspian Image $FILE_RASPBIAN downloaded"
	echo
  fi
}

Decompress_OS_Image () {
  local FILE_RASPBIAN=`echo $RASPIAN_OS | awk -F"/" '{ print $NF }'`
  
  echo "          Decompressing Raspbian Image ..."                           
  echo
  unzip -o $FILE_RASPBIAN
  if [ $? -ne 0 ] ; then                                                                  
    echo
	echo "          ==> ERROR : Unable to unzip Raspbian Image $FILE_RASPIAN"
	exit 1
  else 
    RASPBIAN_IMG=`unzip -l *.zip | grep img | awk -F" " '{ print $NF }'`
    echo
	echo "          Raspian Image $RASPBIAN_IMG available"
	echo
  fi
  echo "          Deleting Archive $FILE_RASPBIAN"
  echo
  rm -f $FILE_RASPBIAN
}

Mount_OS_Image () {
  local OFFSET_P1=0
  local OFFSET_P2=0
  
  echo "          Mounting Image $RAPBIAN_IMG for moOde audio settings"
  echo
  OFFSET_P1=`parted $RASPBIAN_IMG unit B print | tail -3 | head -1 | awk -F" " '{ print $2 }' | awk -F"B" '{ print $1 }'`
  OFFSET_P2=`parted $RASPBIAN_IMG unit B print | tail -2 | head -1 | awk -F" " '{ print $2 }' | awk -F"B" '{ print $1 }'`
  mkdir $MYPATH/p1
  mkdir $MYPATH/p2
  mount -v -o offset=$OFFSET_P1 $RASPBIAN_IMG $MYPATH/p1 > /dev/null
  if [ $? -ne 0 ] ; then                                                                  
    echo "          ==> ERROR : Unable to mount first partition of $RASPBIAN_IMG"
	rmdir $MYPATH/p1
	rmdir $MYPATH/p2
	exit 1       
  fi
  mount -v -o offset=$OFFSET_P2 $RASPBIAN_IMG $MYPATH/p2 > /dev/null
  if [ $? -ne 0 ] ; then                                                                  
    echo "          ==> ERROR : Unable to mount second partition of $RASPBIAN_IMG"
	umount $MYPATH/p1
	rmdir $MYPATH/p2
	rmdir $MYPATH/p2
	exit 1       
  fi
  echo "          $RASPBIAN_IMG partitions mounted sur $MYPATH/p1 et $MYPATH/p2"
  echo
}

Modify_OS_Image () {

  echo "          Modifying Raspian Image for first Device Booting..."                                          
  echo
  touch $MYPATH/p1/ssh
  echo "          SSH activated"
  echo
  sed -i "s/init=.*//" $MYPATH/p1/cmdline.txt
  sed -i "s/init=.*//" $MYPATH/p1/cmdline.txt
  rm $MYPATH/p2/etc/init.d/resize2fs_once
  rm $MYPATH/p2/etc/rc3.d/S01resize2fs_once
  echo "          resize2fs deleted in $RASPBIAN_IMG (no expand at first boot)"
  echo
  sed -i "s/^/net.ifnames=0 /" $MYPATH/p1/cmdline.txt
  echo "          consistent network device naming disabled in $RASPBIAN_IMG"
  echo
  mkdir $MYPATH/p2$PIPATH
  cp -f install_moOde* $MYPATH/p2$PIPATH
  echo "0" >> $MYPATH/p2$STEPFILE
  chmod +x $MYPATH/p2$PIPATH/install_moOde.sh
  chown -R 1000.1000 $MYPATH/p2$PIPATH
  echo "          Install MoOde scripts copied in $RASPBIAN_IMG"
  echo
  sed -i "s/^exit.*//" $MYPATH/p2/etc/rc.local
  echo "$PIPATH/install_moOde.sh $ENV_PROPERTIES_FILE >> $PIPATH/install_moOde_log.txt 2>> $PIPATH/install_moOde_log.txt" >> $MYPATH/p2/etc/rc.local
  echo "exit 0" >> $MYPATH/p2/etc/rc.local
  echo "          moOde scripts autorun in $RASPBIAN_IMG"
  echo
  sed -i "s/raspberrypi/moode/" $MYPATH/p2/etc/hostname
  sed -i "s/raspberrypi/moode/" $MYPATH/p2/etc/hosts
  echo "          hostname device and /etc/hosts changed in $RASPBIAN_IMG, now it will be moode"
  echo
  sync
}

Extra_Stuff_OS_Image () {
  # Here you can add extra stuff on OS Image
  # Wifi setting must be here if you need it
  # TODO : test wifi in parameter file to set it
  echo "No extra stuff added in $RASPBIAN_IMG currently"
  echo
}

Cleanup_After_Prep () {
  echo "          Cleaning Part ..."
  echo
  umount $MYPATH/p1
  umount $MYPATH/p2
  rmdir $MYPATH/p1
  rmdir $MYPATH/p2 
}

Identify_SDCARD () {
  local answer="NO"
  local SDDISK=""
  
  echo "          Verify that the SD Card you want to write is not connected (y/n)? "
  while [ $answer != "YES" ] ; do
    old_stty_cfg=$(stty -g)
    stty raw -echo ; answer=$(head -c 1) ; stty $old_stty_cfg
    if echo "$answer" | grep -iq "^y" ; then
      echo Yes
	  answer="YES"
    else
      echo "          Remove the SDCard you want to write and answer y, Did you dit it ? (y/n) ? "
	  answer="NO"
    fi
  done	
  ls /dev/disk/by-id | grep -v part > $MYPATH/SDCARD_before.txt
  answer="NO"
  echo
  echo "          Were are going to identify the SDCard to write !"
  echo
  echo "          Plug you SDCard on the system, is it OK ? (y/n) ?"
  while [ $answer != "YES" ] ; do
    old_stty_cfg=$(stty -g)
    stty raw -echo ; answer=$(head -c 1) ; stty $old_stty_cfg
    if echo "$answer" | grep -iq "^y" ; then
      echo Yes
	  answer="YES"
    else
      echo "          Plug the SDCard you want to write and answer y, Did you dit it ? (y/n) ? "
	  answer="NO"
    fi
  done	
  ls /dev/disk/by-id | grep -v part > $MYPATH/SDCARD_after.txt
  sort $MYPATH/SDCARD_before.txt > $MYPATH/before_SDCARD.txt
  rm -f $MYPATH/SDCARD_before.txt
  sort $MYPATH/SDCARD_after.txt > $MYPATH/after_SDCARD.txt
  rm -f $MYPATH/SDCARD_after.txt
  SDDISK=`comm -13 $MYPATH/before_SDCARD.txt $MYPATH/after_SDCARD.txt`
  SDDEV=`readlink -f /dev/disk/by-id/$SDDISK`
  rm -f $MYPATH/before_SDCARD.txt
  rm -f $MYPATH/after_SDCARD.txt
  echo "          It seems that your SDCard is $SDDEV"
  echo "          To help you to confirm, here is a list of you different drives and parts :"
  echo
  echo
  blkid
  echo
  echo
  ls -la /dev/disk/by-id
  echo
  echo
  answer="NO"
  echo "          Could you confirm that $SDDEV is the good one ? (y/n) ?"
  while [ $answer != "YES" ] ; do
    old_stty_cfg=$(stty -g)
    stty raw -echo ; answer=$(head -c 1) ; stty $old_stty_cfg
    if echo "$answer" | grep -iq "^y" ; then
      echo Yes
	  answer="YES"
	  return 0
    else
      if echo "$answer" | grep -iq "^n" ; then
	    answer="YES"
		SDDEV="/dev/null"
	  else
	    echo
	    echo "          Confirm it by pressing y or n ! "
	    answer="NO"
      fi
    fi
  done	
}

Write_SDCARD () {
  local answer="NO"
  
  echo
  echo "          At this stage, we are going to write the SD card with the image"
  echo "	      This will be destroy anything previously existing on the SD card"
  echo
  echo "          BE CAREFUL, are you sure you want to write $RASPBIAN_IMG on $SDDEV (y/n) ?"
  while [ $answer != "YES" ] ; do
    old_stty_cfg=$(stty -g)
    stty raw -echo ; answer=$(head -c 1) ; stty $old_stty_cfg
    if echo "$answer" | grep -iq "^y" ; then
      echo Yes
	  answer="YES"	  
    else
      if echo "$answer" | grep -iq "^n" ; then
	    echo
		echo "          You choose to abort the process, the img file is still on your disk"
		echo "          You will find it here : $MYPATH/$RASPBIAN_IMG so you can flash the SD card yourself"
		echo "			In this case, just put the SD card in your device and start it, the install processus will resume"
		exit 1
	  else
	    echo
	    echo "          Confirm it by pressing y or n ! "
	    answer="NO"
      fi
    fi
  done
  answer="NO"
  echo
  echo "          Are you really sure to understand what this mean for $SDDEV ?"
  echo "          if so, let me ask you for the last time to confirm, could we destroy any data on $SDDEV and write $RASPBIAN_IMG on it ? (y/n)"
    while [ $answer != "YES" ] ; do
    old_stty_cfg=$(stty -g)
    stty raw -echo ; answer=$(head -c 1) ; stty $old_stty_cfg
    if echo "$answer" | grep -iq "^y" ; then
      echo Yes
	  answer="YES"	  
    else
      if echo "$answer" | grep -iq "^n" ; then
	    echo
		echo "          You choose to abort the process, the img file is still on your disk"
		echo "          You will find it here : $MYPATH/$RASPBIAN_IMG so you can flash the SD card yourself"
		echo "			In this case, just put the SD card in your device and start it, the install processus will resume"
		exit 1
	  else
	    echo
	    echo "          Confirm it by pressing y or n ! "
	    answer="NO"
      fi
    fi
  done
  echo 
  echo "          Deleting all data on $SDDEV"
  dd if=/dev/zero of=$SDDEV bs=512 count=1
  echo "          Writing the modified $RASPBIAN_IMG on $SDDEV (it could take some time, so don't stop it)"
  dd if=$MYPATH/$RASPBIAN_IMG of=$SDDEV
  echo
  sync
  if [ $? -eq 0 ] ; then
    echo "          The SD card is ready !"
  else
    echo "          Problem during writing process on SD card, check it before booting your device"
  fi
  echo
  rm -f $MYPATH/$RASPBIAN_IMG
}

PI_moOde_Step3 () {
  local FILE_MOODE=`echo $MOODE_RELEASE | awk -F"/" '{ print $NF }'`
  
  echo " ***** STEP 3 : Expand after first boot ... *****"
  echo
  echo "pi:moodeaudio" | chpasswd
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Couldn't change password for pi user"
	exit 1
  else
    echo "          Password changed"
  fi
  echo
  cd $PIPATH
  echo
  echo "          Downloading MoOde Release from $MOODE_RELEASE"
  echo  
  wget $MOODE_RELEASE
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to download MoOde Release at : $MOODE_RELEASE"
	exit 1 
  else 
    echo "          MoOde Release downloaded from $MOODE_RELEASE"
	echo
  fi
  echo "          Decompressing MoOde Release ..."                           
  echo
  unzip -o $FILE_MOODE
  if [ $? -ne 0 ] ; then                                                                  
    echo
	echo "          ==> ERROR : Unable to unzip MoOde Release $FILE_MOODE"
	exit 1
  fi 
  echo
  echo "          MoOde release available"
  echo 
  echo "          Deleting Archive $FILE_RASPBIAN"
  echo
  rm -f $FILE_MOODE
  echo "          Expanding SD card to 3Gb"
  echo 
  cp $PIPATH/rel-stretch/www/command/resizefs.sh $PIPATH
  chmod 0755 $PIPATH/resizefs.sh
  sed -i "/PART_END=/c\PART_END=+3000M" $PIPATH/resizefs.sh
  $PIPATH/resizefs.sh start
  rm $PIPATH/resizefs.sh
  cp $PIPATH/rel-stretch/boot/config.txt.default /boot/config.txt
  echo "          SD Card expanded to 3Gb"
  echo 
  echo "1" > $STEPFILE
  sync
  reboot
}

Some_Basic_Opti () {
  echo 
  echo "          Disabling and Removing Swap"
  echo
  dphys-swapfile swapoff
  update-rc.d dphys-swapfile remove
  rm /var/swap
  echo 
  echo "          Tuning Services"
  echo 
  systemctl disable cron.service
  systemctl enable rpcbind
  echo 
  echo "          Deleting package and conf files for trgiggerhappy"
  echo "              After sleeping some sec.                     "
  echo  
  DEBIAN_FRONTEND=noninteractive apt-get -y purge triggerhappy
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to purge triggerhappy"
	exit 1 
  else 
    echo "          triggerhappy purged"
	echo
  fi
  echo
}

Update_Raspbian () {
  if [ -z "$http_proxy" ] ; then
    echo 
    echo "          No proxy detected"
    echo
  else
    echo 
    echo "          Setting proxy for APT"
    echo
    echo "Acquire::http::Proxy \"$http_proxy\";" > /etc/apt/apt.conf.d/10proxy
  fi
  echo 
  echo "          Updating package list"
  echo 
  DEBIAN_FRONTEND=noninteractive apt-get update
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to update Raspbian package list"
	exit 1 
  else 
    echo "          Raspbian package list updated"
	echo
  fi
  echo 
  echo "          Upgrading packages to the last ones"
  echo  
  DEBIAN_FRONTEND=noninteractive apt-get -y upgrade
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to upgrade Raspbian packages to last ones"
	exit 1 
  else 
    echo "          Raspbian packages upgraded to last ones"
	echo
  fi
  echo 
  echo "          System updated ... go for new reboot "
  echo
  echo "2" > $STEPFILE
  sync
  reboot
}

Install_Extra_Packages () {
  echo 
  echo "          Installing extra packages (nginx, sqlite, shellinabox, ...)"
  echo 
  DEBIAN_FRONTEND=noninteractive  apt-get -y install rpi-update php-fpm nginx sqlite3 php-sqlite3 memcached php-memcache mpc \
                                                     bs2b-ladspa libbs2b0 libasound2-plugin-equal telnet automake sysstat squashfs-tools tcpdump shellinabox \
                                                     samba smbclient udisks-glue ntfs-3g exfat-fuse git inotify-tools libav-tools
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to install extra packages"
	exit 1 
  else 
    echo "          Extra packages (nginx, sqlite, shellinabox, ...) installed"
	echo
  fi													 
  echo 
  echo "          Disabling shellinabox service"
  echo
  systemctl disable shellinabox
  echo 
  echo "          Installing Host AP Mode"
  echo
  DEBIAN_FRONTEND=noninteractive apt-get -y install dnsmasq hostapd
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to install hostapd or dnsmasq"
	exit 1 
  else 
    echo "          hostapd and dnsmasq installed"
	echo
  fi
  echo 
  echo "          Disabling hostapd dnsmasq services"
  echo
  systemctl daemon-reload
  systemctl disable hostapd
  systemctl disable dnsmasq
  echo 
  echo "          Installing Bluetooth"
  echo
  DEBIAN_FRONTEND=noninteractive apt-get -y install bluez bluez-firmware pi-bluetooth \
                                                    dh-autoreconf expect libortp-dev libbluetooth-dev libasound2-dev \
                                                    libusb-dev libglib2.0-dev libudev-dev libical-dev libreadline-dev libsbc1 libsbc-dev

  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to install Bluetooth"
	exit 1 
  else 
    echo "          Bluetooth stuff installed"
	echo
  fi
  echo 
  echo "          Preparing Bluez-alsa ecosystem for building"
  echo
  mkdir $PIPATH/work
  cd $PIPATH/work
  git clone $BLUE_ALSA_GIT
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to clone git at $BLUE_ALSA_GIT"
	exit 1 
  else 
    echo "          Git Bluez-alsa cloned from $BLUE_ALSA_GIT"
	echo
  fi
  cd bluez-alsa
  echo 
  echo "          Building Bluez-alsa"
  echo 
  autoreconf --install
  # No test -- ignore warnings - TODO - look at return codes
  mkdir build
  cd build
  ../configure --disable-hcitop --with-alsaplugindir=/usr/lib/arm-linux-gnueabihf/alsa-lib
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to configure bluez-alsa"
	exit 1 
  else 
    echo "          bluez-alsa configured"
	echo
  fi
  Identify_nb_core
  make -j $PARALLEL
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : During compilation bluez-alsa"
	exit 1 
  else 
    echo "          Bluez-alsa compiled"
	echo
  fi
  make install
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to install bluez-alsa"
	exit 1 
  else 
    echo "          bluez-alsa installed"
	echo
  fi
  cd $PIPATH
  echo 
  echo "          Cleaning Bluez-alsa ecosystem"
  echo 
  rm -rf $PIPATH/work
  echo 
  echo "          Verifying BluezAlsa service"
  echo
  if [ ! -f /lib/systemd/system/bluealsa.service ] ; then
    echo 
    echo "          Creating BluezAlsa service"
    echo
	echo "[Unit]" > /lib/systemd/system/bluealsa.service
	echo "Description=BluezAlsa proxy" >> /lib/systemd/system/bluealsa.service
	echo "Requires=bluetooth.service" >> /lib/systemd/system/bluealsa.service
	echo "After=bluetooth.service" >> /lib/systemd/system/bluealsa.service
	echo >> /lib/systemd/system/bluealsa.service
	echo "[Service]" >> /lib/systemd/system/bluealsa.service
	echo "Type=simple" >> /lib/systemd/system/bluealsa.service
	echo "User=bluealsa" >> /lib/systemd/system/bluealsa.service
	echo "Group=audio" >> /lib/systemd/system/bluealsa.service
	echo "ExecStart=/usr/bin/bluealsa" >> /lib/systemd/system/bluealsa.service
	echo >> /lib/systemd/system/bluealsa.service
	echo "[Install]" >> /lib/systemd/system/bluealsa.service
	echo "WantedBy=multi-user.target" >> /lib/systemd/system/bluealsa.service
	echo >> /lib/systemd/system/bluealsa.service
  else
    echo 
    echo "          BluezAlsa service is already defined"
    echo
  fi
  echo 
  echo "          Disabling alsa services ..."
  echo
  systemctl daemon-reload
  systemctl disable bluetooth.service
  systemctl disable bluealsa.service
  systemctl disable hciuart.service
  echo 
  echo "          Finishing up"
  echo
  mkdir -p /var/run/bluealsa
  sync
  DEBIAN_FRONTEND=noninteractive apt-get clean
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : cleaning bluez-alsa ecosystem"
	exit 1 
  else 
    echo "          bluez-alsa cleaned with apt-get clean"
	echo
  fi
  echo 
  echo "          Blue alsa ok ... go for new reboot "
  echo
  echo "3" > $STEPFILE
  sync
  reboot
}

Install_Wiring_Rotenc () {
  local FILE_WIRINGTAR=`ls $PIPATH/rel-stretch/other/wiringpi/wir* | head -1 | awk -F"/" '{ print $NF }'`
  local FILE_WIRING=`tar tzf $PIPATH/rel-stretch/other/wiringpi/$FILE_WIRINGTAR | head -1 | awk -F"/" '{ print $1 }'`
  
  echo 
  echo "          Copying Wiring $FILE_WIRINGTAR from MoOde distrib"
  echo
  cp $PIPATH/rel-stretch/other/wiringpi/$FILE_WIRINGTAR $PIPATH
  cd $PIPATH
  echo 
  echo "          Inflating Wiring $FILE_WIRINGTAR from MoOde distrib"
  echo
  tar xfz $PIPATH/$FILE_WIRINGTAR
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to inflate wiringPI"
	exit 1 
  else 
    echo "          WiringPI inflated"
	echo
  fi
  cd $PIPATH/$FILE_WIRING
  echo 
  echo "          Building Wiring from MoOde distrib"
  echo 
  $PIPATH/$FILE_WIRING/build
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to build wiringPI from $PIPATH/$FILE_WIRING"
	exit 1 
  else 
    echo "          WiringPI builded"
	echo
  fi
  cd $PIPATH
  rm -rf $PIPATH/$FILE_WIRING
  rm $PIPATH/$FILE_WIRINGTAR
  echo "          WiringPI stuff cleaned"
  echo 
  echo "          Installing rotenc from MoOde distrib"
  echo  
  cp $PIPATH/rel-stretch/other/rotenc/rotenc.c $PIPATH
  gcc -std=c99 rotenc.c -orotenc -lwiringPi
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to compile rotenc"
	exit 1 
  else 
    echo "          rotenc compiled"
	echo
  fi
  cp $PIPATH/rotenc /usr/local/bin
  echo "          rotenc copied to /usr/local/bin"
  echo
  rm $PIPATH/rotenc*
  echo "          rotenc stuff cleaned"
  echo
}

Install_MDP () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  No reboot - Step 7                         **"
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  local FILE_MPD=`echo $MPD_RELEASE | awk -F"/" '{ print $NF }'`
  local DIR_MPD=`echo $FILE_MPD | awk -F".tar.xz" '{ print $1}'`
  
  echo 
  echo "          Preparing MPD environment"
  echo 
  useradd mpd
  mkdir /var/lib/mpd
  mkdir /var/lib/mpd/music
  mkdir /var/lib/mpd/playlists
  touch /var/lib/mpd/state
  chown -R mpd:audio /var/lib/mpd
  mkdir /var/log/mpd
  touch /var/log/mpd/mpd.log
  chmod 644 /var/log/mpd/mpd.log
  chown -R mpd:audio /var/log/mpd
  cp $PIPATH/rel-stretch/mpd/mpd.conf.default /etc/mpd.conf
  chown mpd:audio /etc/mpd.conf
  chmod 0666 /etc/mpd.conf
  echo "          MPD environment ready"
  echo  
  echo "          Installing MPD requirement (libs)"
  echo
  DEBIAN_FRONTEND=noninteractive apt-get -y install libmad0-dev libmpg123-dev libid3tag0-dev \
                     libflac-dev libvorbis-dev libfaad-dev \
                     libwavpack-dev libavcodec-dev libavformat-dev \
                     libmp3lame-dev libsoxr-dev libcdio-paranoia-dev libiso9660-dev \
                     libcurl4-gnutls-dev libasound2-dev libshout3-dev libyajl-dev \
                     libmpdclient-dev libavahi-client-dev libsystemd-dev \
                     libwrap0-dev libboost-dev libicu-dev libglib2.0-dev
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to install libs for MPD"
	exit 1 
  else 
    echo "          libs for MPD installed compiled"
	echo
  fi 
  echo "          Download MPD sources"
  echo  
  wget $MPD_RELEASE
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to download MPD Release at : $MPD_RELEASE"
	exit 1 
  else 
    echo "          MPD Release downloaded from $MPD_RELEASE"
	echo
  fi
  tar xf $FILE_MPD
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to inflate MPD Release"
	exit 1 
  else 
    echo "          MPD Release inflated"
	echo
  fi
  echo "          Setting Up the build system for MPD "
  echo
  cd $PIPATH/$DIR_MPD
  $PIPATH/$DIR_MPD/autogen.sh
  if [ $? -ne 0 ] ; then
    echo
    echo "          ==> ERROR : Unable to set up build system for MPD"
	exit 1 
  else
    echo  
    echo "          MPD build system OK"
	echo
  fi
  $PIPATH/$DIR_MPD/configure --enable-database --enable-libmpdclient --enable-alsa \
                             --enable-curl --enable-dsd --enable-ffmpeg --enable-flac \
                             --enable-id3 --enable-soundcloud --enable-lame-encoder --enable-mad \
                             --enable-mpg123 --enable-pipe-output --enable-recorder-output --enable-shout \
                             --enable-vorbis --enable-wave-encoder --enable-wavpack --enable-httpd-output \
                             --enable-soxr --with-zeroconf=avahi \
                             --disable-bzip2 --disable-zzip --disable-fluidsynth --disable-gme \
                             --disable-wildmidi --disable-sqlite --disable-jack --disable-ao --disable-oss \
                             --disable-ipv6 --disable-pulse --disable-nfs --disable-smbclient \
                             --disable-upnp --disable-expat --disable-lsr \
                             --disable-sndfile --disable-audiofile --disable-sidplay
  if [ $? -ne 0 ] ; then
    echo
    echo "          ==> ERROR : Unable to configure MPD for compilation"
	exit 1 
  else
    echo  
    echo "          MPD ready to compile"
	echo
  fi
  Identify_nb_core
  make -j $PARALLEL
  if [ $? -ne 0 ] ; then
    echo
    echo "          ==> ERROR : Unable to compile MDP"
	exit 1 
  else
    echo  
    echo "          MPD compiled"
	echo
  fi
  make install
  if [ $? -ne 0 ] ; then
    echo
    echo "          ==> ERROR : Unable to install MDP build"
	exit 1 
  else
    echo  
    echo "          MPD build installed"
	echo
  fi
  echo "          Discard unneeded symbols from MPD binary"
  echo  
  strip --strip-unneeded /usr/local/bin/mpd
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to discard symbols from MPD binary"
	exit 1 
  else 
    echo "          MPD binary symbols cleaned"
	echo
  fi  
  cd $PIPATH
  rm -rf $PIPATH/"$DIR_MPD"*
  DEBIAN_FRONTEND=noninteractive apt-get clean
  if [ $? -ne 0 ] ; then
    echo "          ==> ERROR : Unable to clean up apt after MPD"
	exit 1 
  else 
    echo "          apt cleaned after MPD"
	echo
  fi  
  DEBIAN_FRONTEND=noninteractive apt-get autoremove
  if [ $? -ne 0 ] ; then
    echo
    echo "          ==> ERROR : Unable to remove packages no more needed after MPD"
	exit 1 
  else
    echo  
    echo "          packages no more needed removed after MPD"
	echo
  fi
  echo "          MPD ok ... go for new reboot "
  echo
  echo "4" > $STEPFILE
  sync
  reboot  
}

Create_Moode_Env () {
  echo 
  echo "          Creating Moode environment"
  echo 
  echo "          Updating /etc/sudoers"
  echo
  echo "pi\tALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
  echo "www-data\tALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
  echo "          Creating directory tree /var/local/www"
  echo
  mkdir /var/local/www
  mkdir /var/local/www/commandw
  mkdir /var/local/www/cssw
  mkdir /var/local/www/jsw
  mkdir /var/local/www/imagesw
  mkdir /var/local/www/imagesw/toggle
  mkdir /var/local/www/db
  mkdir /var/local/www/templatesw
  chmod -R 0755 /var/local/www
  echo "          Creating directories for MoOde sources"
  echo 
  mkdir /var/lib/mpd/music/RADIO
  mkdir /mnt/NAS
  mkdir /mnt/SDCARD
  mkdir /mnt/UPNP
  echo "          Linking directories for MPD"
  echo
  ln -s /mnt/NAS /var/lib/mpd/music/NAS
  ln -s /mnt/SDCARD /var/lib/mpd/music/SDCARD
  ln -s /media /var/lib/mpd/music/USB
  ln -s /var/lib/mpd/music /var/www/mpdmusic
  echo "          Logs stuff"
  echo
  touch /var/log/moode.log
  chmod 0666 /var/log/moode.log
  touch /var/log/php_errors.log
  chmod 0666 /var/log/php_errors.log
  echo "          Files Stuff"
  echo
  cp $PIPATH/rel-stretch/mpd/sticker.sql /var/lib/mpd
  cp -r "$PIPATH/rel-stretch/other/sdcard/Stereo Test/" /var/lib/mpd/music/SDCARD
  cp $PIPATH/rel-stretch/network/interfaces.default /etc/network/interfaces
  cp $PIPATH/rel-stretch/network/wpa_supplicant.conf.default /etc/wpa_supplicant/wpa_supplicant.conf
  cp $PIPATH/rel-stretch/network/dhcpcd.conf.default /etc/dhcpcd.conf
  cp $PIPATH/rel-stretch/network/hostapd.conf.default /etc/hostapd/hostapd.conf
  cp $PIPATH/rel-stretch/var/local/www/db/moode-sqlite3.db.default /var/local/www/db/moode-sqlite3.db
  echo "          Permissions"
  echo
  chmod 0777 /var/lib/mpd/music/RADIO
  chmod -R 0777 /var/local/www/db
  echo "          Deletes"
  echo
  rm -r /var/www/html
  rm /etc/update-motd.d/10-uname
}

Install_Moode () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  No reboot - Step 9                         **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  echo "          Application sources and configs"
  echo  
  rm /var/lib/mpd/music/RADIO/*
  rm /var/www/images/radio-logos/*
  cp $PIPATH/rel-stretch/mpd/RADIO/* /var/lib/mpd/music/RADIO
  cp $PIPATH/rel-stretch/mpd/playlists/* /var/lib/mpd/playlists
  cp -r $PIPATH/rel-stretch/etc/* /etc
  cp -r $PIPATH/rel-stretch/home/* /home/pi
  cp -r $PIPATH/rel-stretch/home/.dircolors /home/pi
  cp -r $PIPATH/rel-stretch/lib/* /lib
  cp -r $PIPATH/rel-stretch/usr/* /usr
  cp -r $PIPATH/rel-stretch/var/* /var
  cp -r $PIPATH/rel-stretch/www/* /var/www
  chmod 0755 /var/www/command/*
  /var/www/command/util.sh "emerald" "2ecc71" "27ae60"
  sqlite3 /var/local/www/db/moode-sqlite3.db "update cfg_system set value='Emerald' where param='themecolor'"
  echo
  echo "          Permissions for service files"
  echo
  echo "                      MPD"
  echo
  chmod 0755 /etc/init.d/mpd
  chmod 0644 /lib/systemd/system/mpd.service
  chmod 0644 /lib/systemd/system/mpd.socket
  echo "                      Bluetooth"
  echo
  chmod 0666 /etc/bluealsaaplay.conf
  chmod 0644 /etc/systemd/system/bluealsa-aplay@.service
  chmod 0644 /etc/systemd/system/bluealsa.service
  chmod 0644 /lib/systemd/system/bluetooth.service
  chmod 0755 /usr/local/bin/a2dp-autoconnect
  echo "                      Rotenc"
  echo
  chmod 0644 /lib/systemd/system/rotenc.service
  echo "                      Udev"
  echo
  chmod 0644 /etc/udev/rules.d/*
  echo "                      Services are started by moOde Worker so lets disable them here"
  echo
  systemctl daemon-reload
  systemctl disable mpd.service
  systemctl disable mpd.socket
  systemctl disable rotenc.service
  echo
  echo "                      Binaries will not have been installed yet, but let's disable the services here"
  echo
  chmod 0644 /lib/systemd/system/squeezelite-armv6l.service
  chmod 0644 /lib/systemd/system/squeezelite-armv7l.service
  systemctl disable squeezelite-armv6l
  systemctl disable squeezelite-armv7l
  chmod 0644 /lib/systemd/system/upmpdcli.service
  systemctl disable upmpdcli.service
  echo "                      Initial permissions for certain files. These also get set during moOde Worker startup"
  echo
  chmod 0777 /var/local/www/playhistory.log
  chmod 0777 /var/local/www/currentsong.txt
  touch /var/local/www/libcache.json
  chmod 0777 /var/local/www/libcache.json
  echo "          Before rebooting, we need to adjust /etc/rc.local"
  echo "          because Moode distriv overwrite it and we need to"
  echo "          set autorun moode install script again"  
  sed -i "s/^exit.*//" /etc/rc.local
  echo "$PIPATH/install_moOde.sh $ENV_PROPERTIES_FILE >> $PIPATH/install_moOde_log.txt 2>> $PIPATH/install_moOde_log.txt" >> /etc/rc.local
  echo "exit 0" >> /etc/rc.local
  echo
  echo "          MoOde ok ... go for new reboot "
  echo
  echo "5" > $STEPFILE
  sync
  reboot
}

Alsaequal () {
  echo
  echo "          Alsaequal"
  echo 
  echo "          NOTE: The alsamixer command below will generate the alsaequal bin file"
  echo
  echo "          Using amixer instead alsamixer due to batch mode" 

  amixer -D alsaequal
  echo "          alsaequal.bin have been created"
  echo
  echo "          alsaequal.bin permissions"
  chmod 0755 /usr/local/bin/alsaequal.bin
  chown mpd:audio /usr/local/bin/alsaequal.bin
  rm /usr/share/alsa/alsa.conf.d/equal.conf
  echo
  echo "          Sleep a bit because mpd could be not ready"
  echo
  sleep 20
  echo "          List before setting outputs MPD"
  mpc outputs
  echo
  echo "          Setting outputs MPD"
  mpc enable only 1
  echo  
  echo "          MPD output OK"
  echo 
  echo "          Alsaequal configuration done"
  echo 
}

Squash_FS () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  No reboot - Step 11                         **"
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo 
  echo  
  echo "          Writing /etc/fstab"
  echo 
  echo "/var/local/moode.sqsh   /var/www        squashfs        ro,defaults     0       0" >>/etc/fstab
  echo  
  cd $PIPATH
  rm /var/local/moode.sqsh
  echo  
  echo "          Squashing FS /var/www"
  echo
  mksquashfs /var/www /var/local/moode.sqsh
  echo  
  echo "          Remove /var/www"
  echo
  rm -rf /var/www/*
  echo  
  echo "          force to Sync FS"
  echo 
  echo "6" > $STEPFILE
  sync
  reboot
}

Last_Kernel () {
  local LASTKERN=""
  
  echo
  echo "          Check if you want to install latest kernel"
  echo
  if [ -z "$LASTKERNEL" ] ; then
      echo "          You don't want to install latest kernel !"
      echo
  else
    LASTKERN=`echo "$LASTKERNEL" | tr 'a-z' 'A-Z' | head -c 1`
    if [ $LASTKERN = "Y" ] ; then
      echo "          Downloading and Installing latest kernel"
      echo
      PRUNE_MODULES=1 rpi-update
      if [ $? -ne 0 ] ; then
        echo
        echo "          ==> ERROR : Unable to update to latest kernel"
	    exit 1 
      else
        echo  
        echo "          Lastest Kernel installed ... go for a new reboot !"
	    echo "7" > $STEPFILE
        sync
        reboot
      fi
    else
      echo "          You didn't set correctly the environment file !"
      echo
      echo "          You can set it again with Y and reboot to apply"
      echo      
      exit 1
    fi   
  fi
  echo "7" > $STEPFILE
  sync
  reboot  
}

Clean_old_modules () {
  if [ -e /lib/modules.bak ] ; then
    echo
    echo "          Cleaning old modules after kernel update"
    echo
    rm -rf /lib/modules.bak
    echo
    echo "          Modules cleaned"
    echo
  fi
}

UI_Tasks () {
  echo
  echo "          Clearing system logs "
  echo
  truncate /var/log/alternatives.log --size 0
  truncate /var/log/apt/history.log --size 0
  truncate /var/log/apt/term.log --size 0
  truncate /var/log/auth.log --size 0
  truncate /var/log/bootstrap.log --size 0
  truncate /var/log/daemon.log --size 0
  truncate /var/log/debug --size 0
  truncate /var/log/dpkg.log --size 0
  truncate /var/log/faillog --size 0
  truncate /var/log/kern.log --size 0
  truncate /var/log/lastlog --size 0
  truncate /var/log/messages --size 0
  truncate /var/log/minidlna.log --size 0
  truncate /var/log/mpd/log --size 0
  truncate /var/log/nginx/access.log --size 0
  truncate /var/log/nginx/error.log --size 0
  truncate /var/log/php7.0-fpm.log --size 0
  truncate /var/log/php_errors.log --size 0
  truncate /var/log/regen_ssh_keys.log --size 0
  truncate /var/log/samba/log.nmbd --size 0
  truncate /var/log/samba/log.smbd --size 0
  truncate /var/log/syslog --size 0
  truncate /var/log/user.log --size 0
  truncate /var/log/wtmp --size 0
  echo
  echo "          Compacting sqlite3 DB "
  echo
  sqlite3 /var/local/www/db/moode-sqlite3.db "vacuum"
  echo
 }
 
 Final_Prep () {
  echo "      *****************************************************************"
  echo "      **                                                             **"
  echo "      **          Building MoOde Audio Procedure  (on Device)        **"
  echo "      **                  No reboot - Step 14                        **" 
  echo "      **                                                             **"
  echo "      *****************************************************************"
  echo
  echo "          Final Prep "
  echo
  echo
  echo "          Check the boot partition "
  echo
  umount /boot
  dosfsck -tawl /dev/mmcblk0p1
  dosfsck -r /dev/mmcblk0p1
  dosfsck -V /dev/mmcblk0p1
  mount /boot
  echo
  echo "          Remove DHCP lease files "
  echo
  rm /var/lib/dhcp/*
  rm /var/lib/dhcpcd5/*
  echo
  echo "          Reset the network config to defaults "
  echo
  cp $PIPATH/rel-stretch/network/interfaces.default /etc/network/interfaces
  cp $PIPATH/rel-stretch/network/wpa_supplicant.conf.default /etc/wpa_supplicant/wpa_supplicant.conf
  cp $PIPATH/rel-stretch/network/dhcpcd.conf.default /etc/dhcpcd.conf
  cp $PIPATH/rel-stretch/network/hostapd.conf.default /etc/hostapd/hostapd.conf
  echo
  echo "          Removing autorun script and step file"
  echo
  cp $PIPATH/rel-stretch/etc/rc.local /etc/rc.local
  rm $STEPFILE
  echo
  echo "          Last reboot ... Moode image is ready "
  echo
  sync
  reboot
 }

######################################################################
###                          Main                                  ###
######################################################################

Load_Properties $1

if [ ! -f $STEPFILE ] ; then 
  Main_Banner
  Download_OS_Image
  Decompress_OS_Image
  Mount_OS_Image
  Modify_OS_Image
  Extra_Stuff_OS_Image
  Cleanup_After_Prep
  Identify_SDCARD
  Write_SDCARD
  exit 0
else
  # On the PI
  STEP=`cat $STEPFILE`
  case $STEP in
    0) 
	  # First Boot on the PI
	  Main_Banner_PI_3
	  PI_moOde_Step3
	  ;;
	1)
	  # Second Boot on PI
	  Main_Banner_PI_4
	  Some_Basic_Opti
	  Update_Raspbian
	  ;;
	2)
	  # third Boot on PI
	  Main_Banner_PI_5
	  Install_Extra_Packages
	  ;;
	3)
	  # Fourth Boot on PI
	  Main_Banner_PI_6
	  Install_Wiring_Rotenc
      Install_MDP
	  ;;
    4)
 	  # Fifth Boot on PI   
 	  Main_Banner_PI_8
      Create_Moode_Env
      Install_Moode
      ;;
    5)
      Main_Banner_PI_10
      # Alsaequal
      Squash_FS
      ;;
    6)
      Main_Banner_PI_12
      Last_Kernel
      ;;
    7)
      Main_Banner_PI_13
      Clean_old_modules
      UI_Tasks
      Final_Prep
      ;;
	*)
	  # Strange ... no reason to go here
	  echo "          Strange arrival in the case"
	  ;;
  esac
  exit 0
fi
